// RubyIndentvOC indent.js
Array.prototype.peek = function(n) {
	if (n == undefined) n = 1;
	return n <= this.length ? this[this.length-n] : null;
};

function main() {
	//J[\̂sE
	var nCurLine = parseInt(Editor.ExpandParameter("$y"));
	var nCurColumn = parseInt(Editor.ExpandParameter("$x"));
	var sCurLine = Editor.GetLineStr(nCurLine).replace(/[\r\n]+$/, "");
	//^u
	var nTabSize = Editor.ChangeTabWidth( 0 );
	var sLongBlank = "                                                                ";
	var sTabUnit = sLongBlank.substr(0, nTabSize);
	//L[
	var cPressed = Indent.GetChar();
	var bSpaceIndent = Plugin.GetOption("Option", "SpaceIndent") == 1 ? true : false;

	var in_embed_doc = false;	//ߍ݃hLg

	var sKeyword = "";
	if (cPressed == "\r") {
		if (nCurColumn != 1) return;
	} else {
		switch (cPressed) {
		case "d":
			if (/^\s*end\s*(#.*)?$/.test(sCurLine)) break;
			return;
		case "e":
			if (/^\s*else\s*(#.*)?$/.test(sCurLine)) break;
			if (/^\s*ensure\s*(#.*)?$/.test(sCurLine)) break;
			if (/^\s*rescue\s*(#.*)?$/.test(sCurLine)) break;
			return;
		case "f":
			if (/^\s*elsif\s*(#.*)?$/.test(sCurLine)) break;
			return;
		case "n":
			if (/^\s*when\s*(#.*)?$/.test(sCurLine)) break;
			return;
		case "}":
			if (/^\s*}\s*(#.*)?$/.test(sCurLine)) break;
			return;
		default:
			return;
		}
		sKeyword = sCurLine.replace(/^\s*([a-z\}]+)\s*(#.*)?$/, "$1");
	}

	var do_indent = false;
	var sIndentCur = "";		//ݍs̃CfgiXy[Xj
	var sIndentPrev = "";	//ÕCfg
	var stIndent = [];
	stIndent.push("");

	//ҏW1sǂݍŉ͂
	for ( var line_no = 1; line_no <= Editor.GetLineCount( 0 ) + 1; line_no++ ) {
//		TraceOut("line_no:"+line_no+" cur_line:" + nCurLine);
		var line_str = Editor.GetLineStr( line_no ).replace(/[\r\n]+$/, "");
		sIndentPrev = sIndentCur;
		sIndentCur = line_str.replace(/^(\s*).*$/, "$1").replace(/\t/g, sTabUnit);
		line_str = line_str.replace(/^\s*/, "");

		if (line_no == nCurLine) {
			break;
		}

		//sERg
		if (line_str == "" || line_str.charAt(0) == "#") continue;

		//ߍ݃hLg
  		if (in_embed_doc && /^=end\b/.test(line_str)) {
			in_embed_doc = false; continue;
		}
		if (/^=begin\b/.test(line_str)) {
			in_embed_doc = true; continue;
		}
		if (in_embed_doc) {
			continue;
		}

		//e폜
		//TODO: s͖Ή
		//TODO: qAhLgΉ
		line_str = line_str.replace(/"([^"]|\\")+"|'([^']|\\')+'|`[^`]+`|\/([^\/]|\\\/)+\//g, "\"\"");

		//Cfg_E
		if (  (/(^\s*|=\s*)(if|unless|until|for|while|case|def|class|module|begin)\b/.test(line_str) && ! /\bend\b/.test(line_str))
			|| /^[^#]*{\s*(\|[\w,\s]+\|)?\s*$/.test(line_str)
			|| /^[^#]*\sdo\s*(\|[\w,\s]+\|)?\s*$/.test(line_str)) {
			stIndent.push(sIndentCur + sTabUnit);
		}
		//CfgAbv
		else if (/^end\b$/.test(line_str)
			|| /^}\s*$/.test(line_str)) {
			while (stIndent.length > 0 && sIndentCur.length < stIndent.peek().length) {
				stIndent.pop();
			}
		}
		//TODO: zEnbV͖̎Ή
	}

	//L[ɂēς
	var reTab = new RegExp(sTabUnit, "g");
	if (cPressed == "\r") {		//sCfg
//		TraceOut("\\r len:"+stIndent.length+" tx:["+stIndent.peek()+"]");
		var sIndentNew = stIndent.length == 0 ? "" : stIndent.peek();
		if (sIndentNew.length < sIndentPrev.length) sIndentNew = sIndentPrev;
		if (bSpaceIndent) {
			Editor.InsText(sIndentNew);
		} else {
			Editor.InsText(sIndentNew.replace(reTab, "\t"));
		}
	} else {					//蕶Cfg
		var sWord = sKeyword;
		var nPeek = 1;
		if (cPressed == "d" || cPressed == "}") {
//			for (var j=1; j<=stIndent.length; j++)
//			TraceOut("d  sIndentCur:["+sIndentCur+"] len:"+stIndent.length+" tx[-"+j+"]:["+stIndent.peek(j)+"]");
			stIndent.pop();
//			TraceOut("d  len:"+stIndent.length);
//			sWord = "end";
		} else {
			nPeek = 2;
		}
		Editor.GoLineTop_Sel();
		Editor.GoLineTop_Sel();
		Editor.InsText(
			(stIndent.length == 0	? ""
			: bSpaceIndent			? stIndent.peek(nPeek)
			:						  stIndent.peek(nPeek).replace(reTab, "\t")
			) + sWord
		);
	}
}

main();
